#region Copyright Syncfusion Inc. 2001 - 2007
//
//  Copyright Syncfusion Inc. 2001 - 2007. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.ComponentModel;
using System.Drawing;
using System.Web.SessionState;
using System.IO;
using System.Runtime.Serialization;
using Syncfusion.Windows.Forms.Diagram;
using System.Runtime.Serialization.Formatters;
using System.Runtime.Serialization.Formatters.Soap;
using System.Runtime.Serialization.Formatters.Binary;

public partial class InteractDiagram : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (this.IsPostBack == false)
        {
            ////string path = Server.MapPath(String.Empty);
            ////path = path + @"\App_Data\SimpleOrgChart.edd";

            //string palettepath = Server.MapPath(String.Empty);
            //palettepath = palettepath + @"\App_Data\Palette.edp";
            ////this.DiagramWebControl1.LoadBinaryDocument(path);
            //SymbolPalette palette = this.LoadPalette(palettepath);
            
            // Enable the diagram for node selection and drag-drop
            this.DiagramWebControl1.EnableNodeSelection = true;
            this.DiagramWebControl1.EnableDragDrop = true;
            Syncfusion.Windows.Forms.Diagram.ConnectionPoint c=new Syncfusion.Windows.Forms.Diagram.ConnectionPoint();
            Syncfusion.Windows.Forms.Diagram.ConnectionPoint c1 = new Syncfusion.Windows.Forms.Diagram.ConnectionPoint();
            Syncfusion.Windows.Forms.Diagram.ConnectionPoint c2 = new Syncfusion.Windows.Forms.Diagram.ConnectionPoint();
            Syncfusion.Windows.Forms.Diagram.ConnectionPoint c3 = new Syncfusion.Windows.Forms.Diagram.ConnectionPoint(); 
            Syncfusion.Windows.Forms.Diagram.ConnectionPoint c4 = new Syncfusion.Windows.Forms.Diagram.ConnectionPoint();
            Syncfusion.Windows.Forms.Diagram.ConnectionPoint c6 = new Syncfusion.Windows.Forms.Diagram.ConnectionPoint();


            Syncfusion.Windows.Forms.Diagram.Rectangle nodeRectHost = new Syncfusion.Windows.Forms.Diagram.Rectangle(50, 50, 200,50);
            c.ConnectionPointType = ConnectionPointType.IncomingOutgoing;
            c.Position = Position.BottomRight;
            nodeRectHost.Ports.Add(c);

            this.DiagramWebControl1.Model.AppendChild(nodeRectHost);

            Syncfusion.Windows.Forms.Diagram.Rectangle nodeRectHost1 = new Syncfusion.Windows.Forms.Diagram.Rectangle(50, 100, 100, 50);
          
            this.DiagramWebControl1.Model.AppendChild(nodeRectHost1);

            Syncfusion.Windows.Forms.Diagram.Rectangle nodeRectHost2 = new Syncfusion.Windows.Forms.Diagram.Rectangle(150, 100, 100, 50);
            this.DiagramWebControl1.Model.AppendChild(nodeRectHost2);

            Syncfusion.Windows.Forms.Diagram.Rectangle nodeRectHost3 = new Syncfusion.Windows.Forms.Diagram.Rectangle(50, 225, 200, 50);
            this.DiagramWebControl1.Model.AppendChild(nodeRectHost3);

            Syncfusion.Windows.Forms.Diagram.Rectangle nodeRectHost4 = new Syncfusion.Windows.Forms.Diagram.Rectangle(50, 275, 100, 50);
          
            this.DiagramWebControl1.Model.AppendChild(nodeRectHost4);

            Syncfusion.Windows.Forms.Diagram.Rectangle nodeRectHost5 = new Syncfusion.Windows.Forms.Diagram.Rectangle(150, 275, 100, 50);
            this.DiagramWebControl1.Model.AppendChild(nodeRectHost5);
            c2.ConnectionPointType = ConnectionPointType.IncomingOutgoing;
            c2.Position = Position.TopRight;
            nodeRectHost5.Ports.Add(c2);

            Syncfusion.Windows.Forms.Diagram.Rectangle nodeRectHost6 = new Syncfusion.Windows.Forms.Diagram.Rectangle(300,75, 100, 225);

            c1.ConnectionPointType = ConnectionPointType.IncomingOutgoing;
            //c1.Position = Position.MiddleLeft;
            c1.OffsetX = 0;
            c1.OffsetY = 25;
            nodeRectHost6.Ports.Add(c1);

            c3.ConnectionPointType = ConnectionPointType.IncomingOutgoing;
            c3.OffsetX = 100;
            c3.OffsetY = 25;
            nodeRectHost6.Ports.Add(c3);


            c6.ConnectionPointType = ConnectionPointType.IncomingOutgoing;
            c6.OffsetX = 0;
            c6.OffsetY = 200;
            nodeRectHost6.Ports.Add(c6);
           
            this.DiagramWebControl1.Model.AppendChild(nodeRectHost6);


            Syncfusion.Windows.Forms.Diagram.Rectangle nodeRectHost7 = new Syncfusion.Windows.Forms.Diagram.Rectangle(500, 50, 200, 50);
            c4.ConnectionPointType = ConnectionPointType.IncomingOutgoing;
            c4.Position = Position.BottomLeft;
            nodeRectHost7.Ports.Add(c4);
            this.DiagramWebControl1.Model.AppendChild(nodeRectHost7);

            Syncfusion.Windows.Forms.Diagram.Rectangle nodeRectHost8 = new Syncfusion.Windows.Forms.Diagram.Rectangle(500, 100, 100, 50);
            this.DiagramWebControl1.Model.AppendChild(nodeRectHost8);

            Syncfusion.Windows.Forms.Diagram.Rectangle nodeRectHost9 = new Syncfusion.Windows.Forms.Diagram.Rectangle(600, 100, 100, 50);
            this.DiagramWebControl1.Model.AppendChild(nodeRectHost9);

            LineConnector conn1 = new LineConnector(new PointF(10, 10), new PointF(20, 20));
            this.DiagramWebControl1.Model.AppendChild(conn1);
            nodeRectHost.Ports[1].TryConnect(conn1.TailEndPoint);
            nodeRectHost6.Ports[1].TryConnect(conn1.HeadEndPoint);

            LineConnector conn2 = new LineConnector(new PointF(10, 10), new PointF(20, 20));
            this.DiagramWebControl1.Model.AppendChild(conn2);
            nodeRectHost5.Ports[1].TryConnect(conn2.TailEndPoint);
            nodeRectHost6.Ports[3].TryConnect(conn2.HeadEndPoint);

            LineConnector conn3 = new LineConnector(new PointF(10, 10), new PointF(20, 20));
            this.DiagramWebControl1.Model.AppendChild(conn3);
            nodeRectHost6.Ports[2].TryConnect(conn3.TailEndPoint);
            nodeRectHost7.Ports[1].TryConnect(conn3.HeadEndPoint);

            Syncfusion.Windows.Forms.Diagram.Label lbl1 = new Syncfusion.Windows.Forms.Diagram.Label();
            lbl1.Text = "Field A";
            lbl1.Position = Position.TopLeft;
            lbl1.OffsetX = 75;
            lbl1.OffsetY = 18;
            nodeRectHost.Labels.Add(lbl1);

            Syncfusion.Windows.Forms.Diagram.Label lbl2 = new Syncfusion.Windows.Forms.Diagram.Label();
            lbl2.Text = "Field B";
            lbl2.Position = Position.Center;
            lbl2.OffsetX = 75;
            lbl2.OffsetY = 18;
            nodeRectHost1.Labels.Add(lbl2);

            Syncfusion.Windows.Forms.Diagram.Label lbl3 = new Syncfusion.Windows.Forms.Diagram.Label();
            lbl3.Text = "Field C";
            lbl3.Position = Position.Center;
            lbl3.OffsetX = 75;
            lbl3.OffsetY = 18;
            nodeRectHost2.Labels.Add(lbl3);

            Syncfusion.Windows.Forms.Diagram.Label lbl4 = new Syncfusion.Windows.Forms.Diagram.Label();
            lbl4.Text = "Field D";
            lbl4.Position = Position.Center;
            lbl4.OffsetX = 75;
            lbl4.OffsetY = 18;
            nodeRectHost6.Labels.Add(lbl4);

            Syncfusion.Windows.Forms.Diagram.Label lbl5 = new Syncfusion.Windows.Forms.Diagram.Label();
            lbl5.Text = "Field E";
            lbl5.Position = Position.Center;
            lbl5.OffsetX = 75;
            lbl5.OffsetY = 18;
            nodeRectHost7.Labels.Add(lbl5);

            Syncfusion.Windows.Forms.Diagram.Label lbl6 = new Syncfusion.Windows.Forms.Diagram.Label();
            lbl6.Text = "Field F";
            lbl6.Position = Position.TopCenter;
            lbl6.OffsetX = 25;
            lbl6.OffsetY = -5;
            ((LineConnector)conn1).Labels.Add(lbl6);


          
        }
        this.DiagramWebControl1.RenderImageMap = true;
    }
    private void AppendNodeToDocument(Node node, PointF ptLocation)
    {
        if (node == null) throw new ArgumentNullException("node");

        SizeF szPinOffset = ((IUnitIndependent)node).GetPinPointOffset(MeasureUnits.Pixel);
        ((IUnitIndependent)node).SetPinPoint(new PointF(ptLocation.X + szPinOffset.Width, ptLocation.Y + szPinOffset.Height), MeasureUnits.Pixel);
        this.DiagramWebControl1.Model.AppendChild(node);
    }
    public SymbolPalette LoadPalette(string filename)
    {
        SymbolPalette curSymbolPalette = null;
        FileStream iStream = new FileStream(filename, FileMode.Open, FileAccess.Read);

        if (iStream != null)
        {
            IFormatter formatter = new BinaryFormatter();
            try
            {
                AppDomain.CurrentDomain.AssemblyResolve +=
                    new ResolveEventHandler(Syncfusion.DiagramBaseAssembly.AssemblyResolver);
                curSymbolPalette = (SymbolPalette)formatter.Deserialize(iStream);
            }
            catch (SerializationException)
            {
                try
                {
                    formatter = new SoapFormatter();
                    iStream.Position = 0;
                    curSymbolPalette = (SymbolPalette)formatter.Deserialize(iStream);
                }
                catch (Exception e)
                {
                    System.Diagnostics.Trace.WriteLine("Error reading SymbolPalette", e.Message);
                }
            }
            finally
            {
                iStream.Close();
            }
        }

        return curSymbolPalette;
    }
    public Node GetPaletteNode(SymbolPalette palette, string symbolName)
    {
        if (palette == null)
            throw new ArgumentNullException("palette");

        if (symbolName == null)
            throw new ArgumentNullException("symbolName");

        Node nodeToReturn = null;

        foreach (Node node in palette.Nodes)
        {
            if (node.Name == symbolName)
            {
                nodeToReturn = node;
                break;
            }
        }

        return nodeToReturn;
    }
}
